<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKombinUrun ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfKombinUrun
 * @subpackage Arrays
 */
class ArrayOfKombinUrun extends AbstractStructArrayBase
{
    /**
     * The KombinUrun
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\KombinUrun[]
     */
    public $KombinUrun;
    /**
     * Constructor method for ArrayOfKombinUrun
     * @uses ArrayOfKombinUrun::setKombinUrun()
     * @param \StructType\KombinUrun[] $kombinUrun
     */
    public function __construct(array $kombinUrun = array())
    {
        $this
            ->setKombinUrun($kombinUrun);
    }
    /**
     * Get KombinUrun value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\KombinUrun[]|null
     */
    public function getKombinUrun()
    {
        return isset($this->KombinUrun) ? $this->KombinUrun : null;
    }
    /**
     * This method is responsible for validating the values passed to the setKombinUrun method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKombinUrun method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKombinUrunForArrayConstraintsFromSetKombinUrun(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKombinUrunKombinUrunItem) {
            // validation for constraint: itemType
            if (!$arrayOfKombinUrunKombinUrunItem instanceof \StructType\KombinUrun) {
                $invalidValues[] = is_object($arrayOfKombinUrunKombinUrunItem) ? get_class($arrayOfKombinUrunKombinUrunItem) : sprintf('%s(%s)', gettype($arrayOfKombinUrunKombinUrunItem), var_export($arrayOfKombinUrunKombinUrunItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KombinUrun property can only contain items of type \StructType\KombinUrun, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KombinUrun value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\KombinUrun[] $kombinUrun
     * @return \ArrayType\ArrayOfKombinUrun
     */
    public function setKombinUrun(array $kombinUrun = array())
    {
        // validation for constraint: array
        if ('' !== ($kombinUrunArrayErrorMessage = self::validateKombinUrunForArrayConstraintsFromSetKombinUrun($kombinUrun))) {
            throw new \InvalidArgumentException($kombinUrunArrayErrorMessage, __LINE__);
        }
        if (is_null($kombinUrun) || (is_array($kombinUrun) && empty($kombinUrun))) {
            unset($this->KombinUrun);
        } else {
            $this->KombinUrun = $kombinUrun;
        }
        return $this;
    }
    /**
     * Add item to KombinUrun value
     * @throws \InvalidArgumentException
     * @param \StructType\KombinUrun $item
     * @return \ArrayType\ArrayOfKombinUrun
     */
    public function addToKombinUrun(\StructType\KombinUrun $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\KombinUrun) {
            throw new \InvalidArgumentException(sprintf('The KombinUrun property can only contain items of type \StructType\KombinUrun, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KombinUrun[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\KombinUrun|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\KombinUrun|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\KombinUrun|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\KombinUrun|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\KombinUrun|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KombinUrun
     */
    public function getAttributeName()
    {
        return 'KombinUrun';
    }
}
